#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

const int inf = 1e9+1;

int cost[20][20], n;
int sz[2], sum[2][1 << 20];

void find_sum(int t, int v, int lim, int cur = 0) {
    if(v >= lim) {
        sum[t][sz[t]++] = cur;
        return;
    }
    for(int i = 0;i < n;++i)
        find_sum(t, v+1, lim, cur + cost[v][i]);
}
ll cnt(int val) {
    int pos = sz[1]-1;
    ll res = 0;
    for(int i = 0;i < sz[0] && pos >= 0;++i) {
        while(pos >= 0 && sum[0][i] + sum[1][pos] > val) pos--;
        res += pos+1;
    }
    return res;
}
string ans;
ll pos;
bool first_half(int v, int lim, int cur) {
    if(v >= lim) {
        int hv = upper_bound(sum[1], sum[1] + sz[1], cur) - lower_bound(sum[1], sum[1] + sz[1], cur);
        if(hv <= pos) {
            pos -= hv;
            return false;
        }

        return true;
    }
    for(int i = n-1;i >= 0;--i) {
        ans[v] = char(i + 'a');
        if(first_half(v+1, lim, cur - cost[v][i]))
            return true;
    }
    return false;
}

bool second_half(int v, int lim, int cur) {
    if(v >= lim) {
        if(cur)
            return false;
        if(pos > 0) {
            pos--;
            return false;
        }
        return true;
    }
    for(int i = n-1;i >= 0;--i) {
        ans[v] = char(i + 'a');
        if(second_half(v+1, lim, cur - cost[v][i]))
            return true;
    }
    return false;
}

int main() {
    freopen("aliens.in", "r", stdin);
    freopen("aliens.out", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int m;
    ll k;
    cin >> n >> m >> k;
    for(int i = 0;i < m;++i)
    for(int j = 0;j < n;++j)
        cin >> cost[i][j];

    ll hv = 1;
    for(int i = 0;i < m;++i)
        hv *= n;
    k = hv-k;

    find_sum(0, 0, m/2);
    find_sum(1, m/2, m);
    sort(sum[0], sum[0] + sz[0]);
    sort(sum[1], sum[1] + sz[1]);

    int l = 0, r = inf, md;
    while(r > l) {
        md = (l + r) >> 1;
        if(cnt(md) <= k)
            l = md + 1;
        else
            r = md;
    }
    pos = k - cnt(r-1);
    ans = "";
    for(int i = 0;i < m;++i)
        ans += '-';
    first_half(0, m/2, r);
    for(int i = 0;i < m/2;++i)
        r -= cost[i][ans[i]-'a'];

    second_half(m/2, m, r);

    cout << ans << '\n';
    return 0;
}

