/* GCC */
#include <bits/stdc++.h>

using namespace std;

vector<vector<int> > data;
int t, i, j;
const int m = 40000;

void readData(){
    scanf("%d", &t);
    data.resize(t);
    int n, p, c;
    for (int i = 0; i < t; i++){
        scanf("%d%d", &n, &p);
        n--;
        data[i].resize(n);
        for (int z = 0; z < n; z++){
            scanf("%d", &c);
            data[i][z] = c-p;
            p = c;
        }
    }
}

vector<int> getPows(int a, int n){
    vector<int> s(n+1);
    s[0] = 1;
    for (int i = 1; i <= n; i++){
        s[i] = (s[i-1]*a)%m;
    }
    return s;
}

bool check(const vector<int>& arr, int a, int b){
    for (int i = 0; i <= (b-a)/2; i++){
        if (arr[a+i] != arr[b-i]) return false;
    }
    return true;
}

int solve(const vector<int>& line){
    int n = (int)line.size();
    int a = 3;
    vector<int> aPows = getPows(a, n-1);
    vector<int> gl(n), hl(n), gr(n), hr(n);
    gl[0] = line[0];
    hl[0] = line[0];
    for (int i = 1; i < n; i++){
        gl[i] = (gl[i-1]+line[i]*aPows[i])%m;
        hl[i] = (hl[i-1]*a+line[i])%m;
    }
    reverse(aPows.begin(), aPows.end());
    gr[n-1] = line[n-1];
    hr[n-1] = line[n-1];
    for (int i = n-2; i >= 0; i--){
        gr[i] = (gr[i+1]+line[i]*aPows[i])%m;
        hr[i] = (hr[i+1]*a+line[i])%m;
    }
    if(hr[1] == gr[1]
    && check(line, 1, n-1)) return 1;
    for (int i = 0; i < n-2; i++){
        if(gl[i] == hl[i]
        && gr[i+2] == hr[i+2]
        && check(line, 0, i)
        && check(line, i+2, n-1)){
            return i+2;
        }
    }
    if(gl[n-2] == hl[n-2]
    && check(line, 0, n-2)) return n;
    return 0;
}

int main(){
    freopen("symmetry.in", "r", stdin);
    freopen("symmetry.out", "w", stdout);
    readData();
    for (int i = 0; i < t; i++){
        int ans = solve(data[i]);
        printf("%d\n", ans);
    }
    return 0;
}

/*
1) 0,5s   32MB;
2) 0,15s  32MB;
*/

































