/* GCC */
#include <bits/stdc++.h>
const int mod = 40009;
using namespace std;
vector<int> getPows(int a, int n)
{
    vector<int> rs(1, 1);
    for(int i = 1; i<=n; i++)
        rs.push_back((rs[i - 1] * a) % mod);
    return rs;
}
bool check(const vector<int> &line, int a , int b)
{
    for(int i = 0; i<=(b -a)/2;i++)
        if(line[a+i] != line[b - i])
            return false;
    return true;
}
int solve()
{
    int n, p, c;
    scanf("%d%d", &n, &p);
    n--;
    vector<int> dat(n);
    for(int i = 0; i<n; i++)
    {
        scanf("%d", &c);
        dat[i] = c - p;
        p = c;
    }
//    }
//    for(int i = 0; i<dat.size(); i++)
//        printf("%d ", dat[i]);
    int a = 3;
    vector<int> hl(n), hr(n), gl(n), gr(n), pws = getPows(a, n - 1);
    gl[0] = hl[0] = dat[0];
    for(int i = 1 ; i<n;i++)
    {
        gl[i] = (gl[i - 1] + dat[i] * pws[i]) % mod;
        hl[i] = (hl[i - 1] * a + dat[i]) % mod;
    }
    reverse(pws.begin(), pws.end());
    gr[n - 1] = hr[n - 1] = dat[n - 1];
    for(int i = n - 2; i>=0; i--)
    {
        gr[i] = (gr[i + 1] + dat[i] * pws[i]) % mod;
        hr[i] = (hr[i + 1] * a + dat[i]) % mod;
    }
    if(gr[1] == hr[1] && check(dat, 1, n - 1)) return 1;
    for(int i = 0; i<n - 2; i++)
        if(gl[i] == hl[i] && gr[i + 2] == hr[i + 2] && check(dat, 0, i) && check(dat, i +2 , n - 1)) return i+2;
    if(gl[n - 2] == hl[n - 2] && check(dat, 0, n - 2)) return n;
    return 0;
}
int main()
{
    freopen("symmetry.in", "r", stdin);
    freopen("symmetry.out", "w", stdout);
    int t;
    scanf("%d", &t);
    while(t--)
        printf("%d\n" ,solve());
    return 0;
}
