#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

ll n, m, S;
vector < vector < ll > > p;
vector < ll > pref_sums, suf_sums;

void generate_pref(ll pos, ll sum)
{
    if (pos == S)
    {
        pref_sums.push_back(sum);
        return;
    }
    for (ll i = 0; i < n; ++i) generate_pref(pos + 1, sum + p [pos][i]);
}

void generate_suf(ll pos, ll sum)
{
    if (pos == m)
    {
        suf_sums.push_back(sum);
        return;
    }
    for (ll i = 0; i < n; ++i) generate_suf(pos + 1, sum + p [pos][i]);
}

ll h(ll x)
{
    return lower_bound(suf_sums.begin(), suf_sums.end(), x) - suf_sums.begin();
}

ll f(ll x)
{
    ll cnt = 0;
    for (ll i = 0; i < pref_sums.size(); ++i) cnt += suf_sums.size() - h(x - pref_sums [i] + 1);
    return cnt;
}

void g1(ll pos, ll sum, ll x, ll &cur)
{
    if (x - sum + 1 < 0) return;
    if (pos == S)
    {
        cur += h(x - sum + 1) - h(x - sum);
        return;
    }
    for (ll i = 0; i < n; ++i) g1(pos + 1, sum + p [pos][i], x, cur);
}

void g2(ll pos, ll sum, ll x, ll &cur)
{
    if (x - sum < 0) return;
    if (pos == m)
    {
        if (x == sum) ++cur;
        return;
    }
    for (ll i = 0; i < n; ++i) g2(pos + 1, sum + p [pos][i], x, cur);
}

int main()
{
    freopen("aliens.in", "r", stdin);
    freopen("aliens.out", "w", stdout);

    ll k;
    cin >> n >> m >> k;
    S = m - m / 2;
    p.resize(m);
    for (ll i = 0; i < m; ++i)
    {
        p [i].resize(n);
        for (ll j = 0; j < n; ++j) cin >> p [i][j];
    }
    generate_pref(0, 0);
    sort(pref_sums.begin(), pref_sums.end());
    generate_suf(S, 0);
    sort(suf_sums.begin(), suf_sums.end());
    ll a = pref_sums [0] + suf_sums [0] - 1, b = pref_sums.back() + suf_sums.back();
    while (b - a > 1)
    {
        ll c = (a + b) / 2;
        if (f(c) < k) b = c;
        else a = c;
    }
    ll l = k - f(b), l1 = 0, len = 0, sum = 0, ans = 0;
    while (len < m)
    {
        ans *= n;
        --ans;
        for (ll i = 0; i < n; ++i)
        {
            ++ans;
            ll cur = 0;
            if (len < S) g1(len + 1, sum + p [len][i], b, cur);
            else g2(len + 1, sum + p [len][i], b, cur);
            if (l1 + cur < l) l1 += cur;
            else
            {
                sum += p [len][i];
                break;
            }
        }
        ++len;
    }
    string s = "";
    while (s.size() < m)
    {
        s += char(ans % n + ll('a'));
        ans /= n;
    }
    for (ll i = m - 1; i >= 0; --i) cout << s [i];
    cout << '\n';
}
