#include<algorithm>
#include<iostream>
#include<cstdio>

using namespace std;

const int N = 1e5+1;

int t, n;
int d[N];

int al[N], ar[N];

int z[N];
int get_a(int* a){
    int l = 0,
        r = 0;
    for(int i = 1; i < n; ++i){
        if(i <= r)
            z[i] = min(z[i-l], r-i+1);
        else z[i] = 0;
        while(i+z[i] < n && d[i+z[i]] == d[z[i]])
            ++z[i];
        if(i+z[i]-1 > r){
            l = i;
            r = i+z[i]-1;
        }
    }
    l = n;
    r = n;
    for(int i = n-1; i >= 0; --i){
        if(i >= l)
            a[i] = min(z[r-i], i-l+1);
        else a[i] = 0;
        while(i-a[i] >= 0 && d[i-a[i]] == d[a[i]])
            ++a[i];
        if(i-a[i]+1 < l){
            l = i-a[i]+1;
            r = i;
        }
    }
}

int main(){
    freopen("symmetry.in", "r", stdin);
    freopen("symmetry.out", "w", stdout);
    ios_base::sync_with_stdio(false);
    cout.tie(0);
    cin.tie(0);
    cin >> t;
    for(int _ = 0; _ < t; ++_){
        cin >> n;
        --n;
        int last, now;
        cin >> last;
        for(int i = 0; i < n; ++i){
            cin >> now;
            d[i] = now - last;
            last = now;
        }
        if(n == 1){
            cout << 0 << '\n';
            continue;
        }
        get_a(al);
        reverse(d, d+n);
        get_a(ar);
        reverse(ar, ar+n);
        if(ar[1] == n-1){
            cout << 1 << '\n';
            continue;
        }
        if(al[n-2] == n-1){
            cout << n << '\n';
            continue;
        }
        bool found = false;
        for(int i = 0; i < n-2; ++i)
            if(al[i] == i+1 && ar[i+2] == n-i-2){
                cout << i+2 << '\n';
                found = true;
                break;
            }
        if(!found)
            cout << 0 << '\n';
    }
}
