#include <bits/stdc++.h>

using namespace std;
int t;
vector<vector<int> > data;
int m = 40000;
vector<int> ans;

void ReadData(){
    freopen("symmetry.in","r",stdin);
    scanf("%d",&t);
    data = vector<vector<int> > (t);
    ans = vector<int>(t);
    for(int i = 0;i<t;i++){
        int a;
        scanf("%d",&a);
        int p = 0,c;
        data[i] = vector<int>(a);
        for(int z = 0;z<a;z++){
            scanf("%d",&c);
            data[i][z] = c-p;
            p = c;
        }
    }
}
bool check(vector<int> &line,int a,int b){
    for(int i = 0;i<=(b-a)/2;i++){
        if(line[a+i] != line[b-i]) return 0;
    }
    return 1;
}
vector<int> GetPows(int a,int n){
    vector<int> s(1,1);
    for(int i = 1;i<=n;i++)
        s.push_back((s[i-1] * a) % m);
    return s;
}
int solve(vector<int> lines){
    int n = lines.size(),z;
    int a = 3;
    vector<int> aPow = GetPows(a,n-1);
    vector<int> hr(n),dr(n),hl(n),dl(n);
    hl[0] = dl[0] = lines[0];
    for(int i = 1;i<n;i++){
        dl[i] = (dl[i-1] + lines[i]*aPow[i]) % m;
        hl[i] = (hl[i-1] * a + lines[i]) % m;
    }
    reverse(aPow.begin(),aPow.end());
    hr[n-1] = dr[n-1] = lines[n-1];
    for(int i = n-2;i >= 0;i--){
        dr[i] = (dr[i+1] + lines[i]*aPow[i]) % m;
        hr[i] = (hr[i+1] * a + lines[i]) % m;
    }
    //reverse(dr.begin(),dr.end());
    //reverse(hr.begin(),hr.end());
    if(hr[1] == dr[1] && check(lines,0,a)) return 1;
    for(int i = 0;i<n-2;i++){
        if(hr[i] == dr[i] && hl[i+2] == dl[i+2] && check(lines,0,i) && check(lines,i+2,n)) return i+2;
    }
    if(hl[n-2] == dl[n-2] && check(lines,0,n-2)) return n;
    return 0;
}
void FileOut(){
    freopen("symmetry.out","w",stdout);
    for(int i = 0;i<t;i++)
        printf("%d\n",ans[i]);
}
int main(){
    ReadData();
    for(int i = 0;i<t;i++)
        ans[i] = solve(data[i]);
    FileOut();
}
